#include <pthread.h>           /* produit.c */
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

/*********** Data Type ***********/

typedef enum
  {
  STATE_WAIT,
  STATE_MULT,
  STATE_ADD,
  STATE_PRINT
  } State;

typedef struct
  {
  State state;
  int * pendingMult;
  pthread_cond_t cond;
  pthread_mutex_t mutex;
  size_t nbIterations;
  size_t size;
  double * v1;
  double * v2;
  double * v3;
  double result;
  } Product;

/*********** Data structure ***********/

Product prod;

/*********** Function ***********/

void initPendingMult(Product * prod)
{
size_t i;
for(i=0;i<prod->size;i++)
  {
  prod->pendingMult[i]=1;
  }
}

int nbPendingMult(Product * prod)
{
size_t i;
int nb=0;
for(i=0;i<prod->size;i++)
  {
  nb+=prod->pendingMult[i];
  }
return(nb);
}

void wasteTime(unsigned long ms)
{
unsigned long t,t0;
struct timeval tv;
gettimeofday(&tv,(struct timezone *)0);
t0=tv.tv_sec*1000LU+tv.tv_usec/1000LU;
do
  {
  gettimeofday(&tv,(struct timezone *)0);
  t=tv.tv_sec*1000LU+tv.tv_usec/1000LU;
  } while(t-t0<ms);
}

/* Initialisation aleatoire d'un vecteur */

void  initVecteur(double *v, size_t size)
{
 size_t i;

 for(i=0;i<size;i++)
 {
  v[i]=10.0*(0.5-((double)rand())/((double)RAND_MAX));
 }
}

/*****************************************************************************/
void * mult(void * data)
{
 /* A completer */

return(data);
}

/*****************************************************************************/
void * add(void * data)
{
 /* A completer */

return(data);
}

/*****************************************************************************/
int main(int argc,char ** argv)
{
 /* Mettre ici des declarations de variables ...*/

 /* Init du generateur de nombres aleatoires */

 srand(time((time_t *)0));

/* Lire le nombre d'iterations et la taille des vecteurs */

  if((argc<=2)||
    (sscanf(argv[1],"%u",&prod.nbIterations)!=1)||
    (sscanf(argv[2],"%u",&prod.size)!=1)||
    ((int)prod.nbIterations<=0)||((int)prod.size<=0))
   {
    fprintf(stderr,"usage: %s nbIterations vectorSize\n",argv[0]);
    return(EXIT_FAILURE);
   }

 /* A completer */

return(EXIT_SUCCESS);
}
